package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.ZCMX;
import com.sa.ibiz.demo.demo.service.ZCMXService;
import com.sa.ibiz.demo.demo.service.dto.ZCMXSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/zcmx")
public class ZCMXResource
{
	@Autowired
	private ZCMXService service;


	@PostMapping(value = "/create")
	public ResponseEntity<ZCMX> create(@Validated @RequestBody ZCMX data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("支出明细[create]操作发生错误","ZCMX",data.getZcmxid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<ZCMX> getDraft(@Validated @RequestBody ZCMX data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("支出明细[getDraft]操作发生错误","ZCMX","");
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<ZCMX> get(@Validated @PathVariable String id){
		ZCMX data=new ZCMX();
		data.setZcmxid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("支出明细[get]操作发生错误","ZCMX",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<ZCMX> update(@Validated @RequestBody ZCMX data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("支出明细[update]操作发生错误","ZCMX",data.getZcmxid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<ZCMX> checkKey(@Validated @RequestBody ZCMX data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("支出明细[checkKey]操作发生错误","ZCMX",data.getZcmxid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<ZCMX> remove(@Validated @RequestBody ZCMX data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("支出明细[remove]操作发生错误","ZCMX",data.getZcmxid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<ZCMX>> searchDefaultPage(@Validated @RequestBody ZCMXSearchFilter filter){
		Page<ZCMX> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<ZCMX>> listDefault(@Validated @RequestBody ZCMXSearchFilter filter){
		List<ZCMX> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
